%
%  PCC2: Special Instructions Test
%


%
%  Test drivers
%
sub assert(value, str)
  pushloc value
  jtp ok
  pushlit "Assertion failed: "
  pushloc str
  bconcempty
  dup 0
  sprint
  sthrow
ok:
endsub

sub call(name, func)
  catch c
  pushlit 92823987   % canary
  pushloc func
  callind 0
  pushlit 92823987
  bcmpeq
  jfe nok
  suncatch
  sreturn 0
nok:
  pushlit "Stack error"
  sthrow
c:
  pushlit "Error in "
  pushloc name
  bconcempty
  pushlit ": "
  bconcempty
  swap 1
  bconcempty
  sprint
  sterminate
endsub


%
%  A failing assertion to test the tester
%
sub failer
  pushlit 0
  pushlit "foo"
  pushlit assert
  callind 2
endsub


%
%  Closure
%
function Closure_Tester(a,b,c,d,e,f,g)
  pushloc a
  pushloc b
  pushloc c
  pushloc d
  pushloc e
  pushloc f
  pushloc g
  bconcempty
  bconcempty
  bconcempty
  bconcempty
  bconcempty
  bconcempty
  sreturn 1
endfunction

sub Closure1
  pushint 1
  pushint 2
  pushint 3
  pushint 4
  pushint 5
  pushint 6
  pushint 7
  pushlit Closure_Tester
  loadind 7
  pushlit "1234567"
  bcmpeq
  pushlit "Closure_Tester"
  pushlit assert
  callind 2
endsub

sub Closure2
  % make a closure
  .local c
  pushlit "a"
  pushlit "b"
  pushlit "c"
  pushlit Closure_Tester
  sbind 3
  poploc c

  % test it
  pushlit 1
  pushlit 2
  pushlit 3
  pushlit 4
  pushloc c
  loadind 4
  pushlit "abc1234"
  bcmpeq
  pushlit "Closure_Tester call"
  pushlit assert
  callind 2

  % bind more args
  pushlit "x"
  pushlit "y"
  pushloc c
  sbind 2
  poploc c

  % test that
  pushlit 1
  pushlit 2
  pushloc c
  loadind 2
  pushlit "abcxy12"
  bcmpeq
  pushlit "Closure_Tester call 2"
  pushlit assert
  callind 2
endsub


%
%  Makelist
%
sub Makelist1
  .local a
  pushlit 'a'
  pushlit 'b'
  pushint 42
  smakelist 3
  poploc a

  % Verify it is one-dimensional
  pushloc a
  uisarray
  pushint 1
  bcmpeq
  pushlit "dimension"
  pushlit assert
  callind 2

  % Verify size
  pushloc a
  pushint 1
  barraydim
  pushint 3
  bcmpeq
  pushlit "dimension"
  pushlit assert
  callind 2

  % Verify content
  pushint 0
  pushloc a
  loadind 1
  pushlit 'a'
  bcmpeq
  pushlit "content 0"
  pushlit assert
  callind 2

  % Verify content
  pushint 1
  pushloc a
  loadind 1
  pushlit 'b'
  bcmpeq
  pushlit "content 0"
  pushlit assert
  callind 2

  % Verify content
  pushint 2
  pushloc a
  loadind 1
  pushint 42
  bcmpeq
  pushlit "content 0"
  pushlit assert
  callind 2
endsub

%
%  jdz
%
sub Jdz1
  % Take the second jump
  pushint 2
  jdz fail
  jdz succeed
  jdz fail
fail:
  pushlit 0
  pushlit "fail 1"
  pushlit assert
  callind 2
succeed:
  drop 1
endsub

sub Jdz2
  % Take the first jump
  pushint 1
  jdz succeed
  jdz fail
  jdz fail
fail:
  pushlit 0
  pushlit "fail 2"
  pushlit assert
  callind 2
succeed:
  drop 1
endsub

sub Jdz3
  % 0 = take no jump
  pushint 0
  jdz fail
  jdz fail
  jdz fail
  j succeed
fail:
  pushlit 0
  pushlit "fail 3"
  pushlit assert
  callind 2
succeed:
  drop 1
endsub

sub Jdz4
  % Take the second jump, this time with float
  pushlit 2.0
  jdz fail
  jdz succeed
  jdz fail
fail:
  pushlit 0
  pushlit "fail 4"
  pushlit assert
  callind 2
succeed:
  drop 1
endsub

sub main
  %pushlit 'failer'
  %pushlit failer
  %pushlit call
  %callind 2

  pushlit "Closure1"
  pushlit Closure1
  pushlit call
  callind 2

  pushlit "Closure2"
  pushlit Closure2
  pushlit call
  callind 2

  pushlit "Makelist1"
  pushlit Makelist1
  pushlit call
  callind 2

  pushlit "Jdz1"
  pushlit Jdz1
  pushlit call
  callind 2

  pushlit "Jdz2"
  pushlit Jdz2
  pushlit call
  callind 2

  pushlit "Jdz3"
  pushlit Jdz3
  pushlit call
  callind 2

  pushlit "Jdz4"
  pushlit Jdz4
  pushlit call
  callind 2
endsub
